// Vehicle_Old_Pickup.cs

datablock TSShapeConstructor(oldpickupDts)
{
	baseShape  = "./pickupv2.dts";
	sequence0  = "./root.dsq root";
	sequence1  = "./t_open.dsq bootlidopen";
	sequence2  = "./t_close.dsq bootlidclose";
	sequence3  = "./h_open.dsq bonnetlidopen";
	sequence4  = "./h_close.dsq bonnetlidclose";
	sequence5  = "./l_open.dsq ldopen";
	sequence6  = "./l_close.dsq ldclose";
	sequence7  = "./r_open.dsq rdopen";
	sequence8  = "./r_close.dsq rdclose";
};  

datablock TSShapeConstructor(oldpickupstepsideDts)
{
	baseShape  = "./pickupstepsidev2.dts";
	sequence0  = "./root.dsq root";
	sequence1  = "./t_open.dsq bootlidopen";
	sequence2  = "./t_close.dsq bootlidclose";
	sequence3  = "./h_open.dsq bonnetlidopen";
	sequence4  = "./h_close.dsq bonnetlidclose";
	sequence5  = "./l_open.dsq ldopen";
	sequence6  = "./l_close.dsq ldclose";
	sequence7  = "./r_open.dsq rdopen";
	sequence8  = "./r_close.dsq rdclose";
};  

datablock WheeledVehicleData(oldpickupVehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./pickupv2.dts";
	emap = true;
	minMountDist = 3;
	
	numMountPoints = 5;
	mountThread[0] = "sit";
	mountThread[1] = "sit";
	mountThread[2] = "root";
	mountThread[3] = "root";
	mountThread[4] = "root";

	maxDamage = 200.00;
	destroyedLevel = 200.00;
	energyPerDamagePoint = 160;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier = 0.02;

	massCenter = "0 0.5 0.2";
	//massBox = "2 5 1";

	maxSteeringAngle = 0.9785; // Maximum steering angle, should match animation
	integration = 4; // Force integration time: TickSec/Rate
	tireEmitter = VehicleTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false; // Roll the camera with the vehicle
	cameraMaxDist = 13; // Far distance from vehicle
	cameraOffset = 7.5; // Vertical offset from camera mount point
	cameraLag = 0.0; // Velocity lag of camera
	cameraDecay = 0.75; // Decay per sec. rate of velocity lag
	cameraTilt = 0.4;
	collisionTol = 0.1; // Collision distance tolerance
	contactTol = 0.1;

	useEyePoint = false;	

	defaultTire = oldpickupTire;
	defaultSpring = oldpickupSpring;
	//flatTire = jeepFlatTire;
	//flatSpring = jeepFlatSpring;

	numWheels = 4;

	// Rigid Body
	mass = 300;
	density = 5.0;
	drag = 1.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10; // Impacts over this invoke the script callback
	softImpactSpeed = 10; // Play SoftImpact Sound
	hardImpactSpeed = 15; // Play HardImpact Sound
	groundImpactMinSpeed = 10.0;

	// Engine
	engineTorque = 10000; // Engine power
	engineBrake = 4000; // Braking when throttle is 0
	brakeTorque = 50000; // When brakes are applied
	maxWheelSpeed = 30; // Engine scale by current speed / max speed

	rollForce = 900;
	yawForce = 600;
	pitchForce = 1000;
	rotationalDrag = 0.2;

	// Advanced Steering
	steeringAutoReturn = true;
	steeringAutoReturnRate = 0.9;
	steeringAutoReturnMaxSpeed = 10;
	steeringUseStrafeSteering = true;
	steeringStrafeSteeringRate = 0.1;

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;	
	hardSplashSoundVelocity = 20.0;	
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//explosion = VehicleExplosion;
	justcollided = 0;

	uiName = "Buck Pickup ";
	rideable = true;
	lookUpLimit = 0.65;
	lookDownLimit = 0.45;

	paintable = true;
	
	damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

	damageEmitter[1] = VehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

	numDmgEmitterAreas = 1;

	initialExplosionProjectile = OldPickupExplosionProjectile;
	initialExplosionOffset = 0; //offset only uses a z value for now

	burnTime = 4000;

	finalExplosionProjectile = OldPickupFinalExplosionProjectile;
	finalExplosionOffset = 0.5; //offset only uses a z value for now

	minRunOverSpeed = 4; //how fast you need to be going to run someone over (do damage)
	runOverDamageScale = 8; //when you run over someone, speed * runoverdamagescale = damage amt
	runOverPushScale = 1.2; //how hard a person you're running over gets pushed

	//protection for passengers
	protectPassengersBurn = false; //protect passengers from the burning effect of explosions?
	protectPassengersRadius = true; //protect passengers from radius damage (explosions) ?
	protectPassengersDirect = false; //protect passengers from direct damage (bullets) ?

	isInteractive = true;
	iNumZones = 4;
	iZone[0] = "-1.8 2.1 1 1.8 5 5";
	iZoneScript[0] = "onHood";
	iZone[1] = "-1.8 -5 0.3 1.8 -3.4 1.5";
	iZoneScript[1] = "onTrunk";
	iZone[2] = "-5 0 0.1 -1.6 1.8 2.6";
	iZoneScript[2] = "onLeftDoor";
	iZone[3] = "1.6 0 0.1 5 1.8 2.6";
	iZoneScript[3] = "onRightDoor";
};

datablock WheeledVehicleData(OldPickupStepSideVehicle : OldPickupVehicle)
{
	//- Vehicle Data -
	
	shapeFile = "./pickupstepsidev2.dts";
	uiName = "Buck Pickup - Stepside";
	
};

function OldPickupVehicle::onAdd(%this,%obj)
{
	parent::onadd(%this,%obj);
	%obj.setWheelTire(0, OldPickupTire);
	%obj.setWheelTire(1, OldPickupTire);
	%obj.setWheelTire(2, OldPickupTire);
	%obj.setWheelTire(3, OldPickupTire);

	%obj.setWheelSpring(0, OldPickupspring);
	%obj.setWheelSpring(1, OldPickupspring);
	%obj.setWheelSpring(2, OldPickupspring);
	%obj.setWheelSpring(3, OldPickupspring);

	%obj.setWheelSteering(0,1);
	%obj.setWheelSteering(1,1);
	%obj.setWheelSteering(2,0);
	%obj.setWheelSteering(3,0);
	
	%obj.hideNode(stepside);
	%obj.hideNode(sslight);
	%obj.hideNode(sstailgate);
	%obj.hideNode(ssbumper);

	%obj.mountable = true;
	%obj.playthread(0, root);

}

function OldPickupStepSideVehicle::onAdd(%this,%obj)
{
	parent::onadd(%this,%obj);
	%obj.setWheelTire(0, OldPickupTire);
	%obj.setWheelTire(1, OldPickupTire);
	%obj.setWheelTire(2, OldPickupTire);
	%obj.setWheelTire(3, OldPickupTire);

	%obj.setWheelSpring(0, OldPickupspring);
	%obj.setWheelSpring(1, OldPickupspring);
	%obj.setWheelSpring(2, OldPickupspring);
	%obj.setWheelSpring(3, OldPickupspring);

	%obj.setWheelSteering(0,1);
	%obj.setWheelSteering(1,1);
	%obj.setWheelSteering(2,0);
	%obj.setWheelSteering(3,0);
	
	%obj.hideNode(fleetside);
	%obj.hideNode(tlight1);
	%obj.hideNode(fstailgate);
	%obj.hideNode(fsbumper);

	%obj.mountable = true;
	%obj.playthread(0, root);

}

function OldPickupVehicle::onHood(%this, %obj, %client, %offset, %position, %vector)
{
	%time = getSimTime();
	if((%time - %obj.hoodTime) > 800)
	{
		%obj.hoodTime = %time;
		%obj.hood = !%obj.hood;
		%obj.playThread(0, %obj.hood ? bonnetlidopen : bonnetlidclose);
	}
	return 1;
}
function OldPickupVehicle::onTrunk(%this, %obj, %client, %offset, %position, %vector)
{
	%time = getSimTime();
	if((%time - %obj.trunkTime) > 800)
	{
		%obj.trunkTime = %time;
		%obj.trunk = !%obj.trunk;
		%obj.playThread(1, %obj.trunk ? bootlidopen : bootlidclose);
	}
	return 1;
}
function OldPickupVehicle::onLeftDoor(%this, %obj, %client, %offset, %position, %vector)
{
	%time = getSimTime();
	if((%time - %obj.leftDoorTime) > 800)
	{
		%obj.leftDoorTime = %time;
		%obj.leftDoor = !%obj.leftDoor;
		%obj.playThread(2, %obj.leftDoor ? ldopen : ldclose);
	}
	return 1;
}
function OldPickupVehicle::onRightDoor(%this, %obj, %client, %offset, %position, %vector)
{
	%time = getSimTime();
	if((%time - %obj.rightDoorTime) > 800)
	{
		%obj.rightDoorTime = %time;
		%obj.rightDoor = !%obj.rightDoor;
		%obj.playThread(3, %obj.rightDoor ? rdopen : rdclose);
	}
	return 1;
}

function OldPickupStepSideVehicle::onHood(%this, %obj, %client, %offset, %position, %vector)
{
	%time = getSimTime();
	if((%time - %obj.hoodTime) > 800)
	{
		%obj.hoodTime = %time;
		%obj.hood = !%obj.hood;
		%obj.playThread(0, %obj.hood ? bonnetlidopen : bonnetlidclose);
	}
	return 1;
}
function OldPickupStepSideVehicle::onTrunk(%this, %obj, %client, %offset, %position, %vector)
{
	%time = getSimTime();
	if((%time - %obj.trunkTime) > 800)
	{
		%obj.trunkTime = %time;
		%obj.trunk = !%obj.trunk;
		%obj.playThread(1, %obj.trunk ? bootlidopen : bootlidclose);
	}
	return 1;
}
function OldPickupStepSideVehicle::onLeftDoor(%this, %obj, %client, %offset, %position, %vector)
{
	%time = getSimTime();
	if((%time - %obj.leftDoorTime) > 800)
	{
		%obj.leftDoorTime = %time;
		%obj.leftDoor = !%obj.leftDoor;
		%obj.playThread(2, %obj.leftDoor ? ldopen : ldclose);
	}
	return 1;
}
function OldPickupStepSideVehicle::onRightDoor(%this, %obj, %client, %offset, %position, %vector)
{
	%time = getSimTime();
	if((%time - %obj.rightDoorTime) > 800)
	{
		%obj.rightDoorTime = %time;
		%obj.rightDoor = !%obj.rightDoor;
		%obj.playThread(3, %obj.rightDoor ? rdopen : rdclose);
	}
	return 1;
}

